<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

class Pracownik_Controller extends Controller
{
	public function indexAction()
	{
		Visitor::verifyAccess(array(Stanowisko::SZEF));
		// sprawdzenie danych z wejscia
		$required = array();
		$required[] = new RequiredVariable('orderColumn', RequiredVariable::TYPE_STRING, 'id', Pracownik::getFieldsList());
		$required[] = new RequiredVariable('order', RequiredVariable::TYPE_STRING, 'ASC', array('DESC', 'ASC'));
		$vars = array();
		if(!self::verifyArguments($_REQUEST, $required, $vars))
		{
			throw new CriticException(__CLASS__ . '::' . __METHOD__ . ' - blad danych wejsciowych: ' . self::getLastError());
		}
		extract($vars);
		// wywolanie odpowiedniej metody na modelu
		$data = array();
		$data['pracownicy'] = new DatabaseList('Pracownik');
		$data['pracownicy']->addOrder(new SQL_Order(new SQL_Field($orderColumn), $order));
		// wywolanie widoku z odpowiednimi danymi
		View::setData($data);
	}

	public function pobierzPrzesylkiJSONAction()
	{
		Visitor::verifyAccess(array(Stanowisko::SZEF));
		View::setIsJSON(true);
		// sprawdzenie danych z wejscia
		$required = array();
		$required[] = new RequiredVariable('pracownikID', RequiredVariable::TYPE_INTEGER);
		$vars = array();
		if(!self::verifyArguments($_REQUEST, $required, $vars))
		{
			throw new CriticException(__CLASS__ . '::' . __METHOD__ . ' - blad danych wejsciowych: ' . self::getLastError());
		}
		extract($vars);
		$pracownik = new Pracownik($pracownikID);
		$data = array();
		if($pracownik->isLoaded())
		{
			$data['przesylkiOdebrane'] = array();
			foreach($pracownik->getListPrzesylkaOdebrana() as $przesylkaOdebrana)
			{
				$tmpPrzesylka = array();
				$tmpPrzesylka['id'] = $przesylkaOdebrana->getID();
				$tmpPrzesylka['imie'] = $przesylkaOdebrana->getImie();
				$tmpPrzesylka['nazwisko'] = $przesylkaOdebrana->getNazwisko();
				$tmpPrzesylka['ulica'] = $przesylkaOdebrana->getUlica();
				$tmpPrzesylka['kod_pocztowy'] = $przesylkaOdebrana->getKodPocztowy();
				$tmpPrzesylka['miejscowosc'] = $przesylkaOdebrana->getMiejscowosc();
				$tmpPrzesylka['telefon'] = $przesylkaOdebrana->getTelefon();
				$tmpPrzesylka['opis_zawartosci'] = $przesylkaOdebrana->getOpisZawartosci();
				$tmpPrzesylka['data_odebrania'] = $przesylkaOdebrana->getDataOdebrania();
				$data['przesylkiOdebrane'][] = $tmpPrzesylka;
			}
			$data['przesylkiNadane'] = array();
			foreach($pracownik->getListPrzesylkaNadana() as $przesylkaNadana)
			{
				$tmpPrzesylka = array();
				$tmpPrzesylka['id'] = $przesylkaNadana->getID();
				$tmpPrzesylka['imie'] = $przesylkaNadana->getImie();
				$tmpPrzesylka['nazwisko'] = $przesylkaNadana->getNazwisko();
				$tmpPrzesylka['ulica'] = $przesylkaNadana->getUlica();
				$tmpPrzesylka['kod_pocztowy'] = $przesylkaNadana->getKodPocztowy();
				$tmpPrzesylka['miejscowosc'] = $przesylkaNadana->getMiejscowosc();
				$tmpPrzesylka['telefon'] = $przesylkaNadana->getTelefon();
				$tmpPrzesylka['opis_zawartosci'] = $przesylkaNadana->getOpisZawartosci();
				$tmpPrzesylka['data_nadania'] = $przesylkaNadana->getDataNadania();
				$data['przesylkiNadane'][] = $tmpPrzesylka;
			}
		}
		else
		{
			$data['error'] = 'Pracownik o ID ' . $pracownikID . ' nie istnieje.';
		}
		$data['pracownikID'] = $pracownikID;
		View::setData($data);
	}

	public function pobierzTransakcjePrzesylekOdebranychJSONAction()
	{
		Visitor::verifyAccess(array(Stanowisko::SZEF));
		View::setIsJSON(true);
		// sprawdzenie danych z wejscia
		$required = array();
		$required[] = new RequiredVariable('przesylkaID', RequiredVariable::TYPE_INTEGER);
		$required[] = new RequiredVariable('pracownikID', RequiredVariable::TYPE_INTEGER);
		$vars = array();
		if(!self::verifyArguments($_REQUEST, $required, $vars))
		{
			throw new CriticException(__CLASS__ . '::' . __METHOD__ . ' - blad danych wejsciowych: ' . self::getLastError());
		}
		extract($vars);
		$przesylkaOdebrana = new PrzesylkaOdebrana($przesylkaID);
		$data = array();
		if($przesylkaOdebrana->isLoaded())
		{
			$data['transakcje'] = array();
			foreach($przesylkaOdebrana->getListTransakcja() as $transakcja)
			{
				$tmpTransakcja = array();
				$tmpTransakcja['id'] = $transakcja->getID();
				$tmpKlient = $transakcja->getKlient();
				$tmpTransakcja['klient_nick_allegro'] = $tmpKlient->getNickAllegro();
				$tmpTransakcja['klient_id_allegro'] = $tmpKlient->getIdAllegroKlienta();
				$tmpAukcja = $transakcja->getAukcja();
				$tmpTransakcja['aukcja_id_allegro'] = $tmpAukcja->getIdAllegroAukcji();
				$tmpTransakcja['aukcja_nazwa'] = $tmpAukcja->getNazwa();
				$tmpTransakcja['ilosc_sztuk'] = $transakcja->getIloscSztuk();
				$tmpTransakcja['data_rozpoczecia'] = $transakcja->getDataRozpoczecia();
				$tmpTransakcja['data_zakonczenia'] = $transakcja->getDataZakonczenia();
				$tmpTransakcja['status_transakcji'] = $transakcja->getStatusTransakcji();
				$data['transakcje'][] = $tmpTransakcja;
			}
		}
		else
		{
			$data['error'] = 'Przesylka odebrana o ID ' . $przesylkaID . ' nie istnieje.';
		}
		$data['przesylkaID'] = $przesylkaID;
		$data['pracownikID'] = $pracownikID;
		View::setData($data);
	}

	public function pobierzTransakcjePrzesylekNadanychJSONAction()
	{
		Visitor::verifyAccess(array(Stanowisko::SZEF));
		View::setIsJSON(true);
		// sprawdzenie danych z wejscia
		$required = array();
		$required[] = new RequiredVariable('przesylkaID', RequiredVariable::TYPE_INTEGER);
		$required[] = new RequiredVariable('pracownikID', RequiredVariable::TYPE_INTEGER);
		$vars = array();
		if(!self::verifyArguments($_REQUEST, $required, $vars))
		{
			throw new CriticException(__CLASS__ . '::' . __METHOD__ . ' - blad danych wejsciowych: ' . self::getLastError());
		}
		extract($vars);
		$przesylkaNadana = new PrzesylkaNadana($przesylkaID);
		$data = array();
		if($przesylkaNadana->isLoaded())
		{
			$data['transakcje'] = array();
			foreach($przesylkaNadana->getListTransakcja() as $transakcja)
			{
				$tmpTransakcja = array();
				$tmpTransakcja['id'] = $transakcja->getID();
				$tmpKlient = $transakcja->getKlient();
				$tmpTransakcja['klient_nick_allegro'] = $tmpKlient->getNickAllegro();
				$tmpTransakcja['klient_id_allegro'] = $tmpKlient->getIdAllegroKlienta();
				$tmpAukcja = $transakcja->getAukcja();
				$tmpTransakcja['aukcja_id_allegro'] = $tmpAukcja->getIdAllegroAukcji();
				$tmpTransakcja['aukcja_nazwa'] = $tmpAukcja->getNazwa();
				$tmpTransakcja['ilosc_sztuk'] = $transakcja->getIloscSztuk();
				$tmpTransakcja['data_rozpoczecia'] = $transakcja->getDataRozpoczecia();
				$tmpTransakcja['data_zakonczenia'] = $transakcja->getDataZakonczenia();
				$tmpTransakcja['status_transakcji'] = $transakcja->getStatusTransakcji();
				$data['transakcje'][] = $tmpTransakcja;
			}
		}
		else
		{
			$data['error'] = 'Przesylka nadana o ID ' . $przesylkaID . ' nie istnieje.';
		}
		$data['przesylkaID'] = $przesylkaID;
		$data['pracownikID'] = $pracownikID;
		View::setData($data);
	}
}