<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

class Aukcja extends Model
{
	protected static $table = 'aukcja';
	protected static $fields = array('id_allegro_aukcja', 'nazwa', 'opis_produktu', 'cena_sztuki', 'data_rozpoczecia', 'data_zakonczenia');

    public function __construct($id = null)
    {
		if($id != null && $id != 0)
			$this->load($id, 'id');
    }

	public static function getFieldsList()
	{
		if(get_parent_class() && method_exists(get_parent_class(), 'getFieldsList'))
		{
			return array_merge(parent::getFieldsList(), self::$fields);
		}
		else
		{
			return self::$fields;
		}
	}

	public static function create($idAllegro, $nazwa, $opisProduktu, $cenaSztuki, $dataRozpoczecia, $dataZakonczenia)
    {
		$aukcja = new Aukcja();
		$aukcja->setIdAllegroAukcji($idAllegro);
		$aukcja->setNazwa($nazwa);
		$aukcja->setOpisProduktu($opisProduktu);
		$aukcja->setCenaSztuki($cenaSztuki);
		$aukcja->setDataRozpoczecia($dataRozpoczecia);
		$aukcja->setDataZakonczenia($dataZakonczenia);
		$aukcja->save();
		return $aukcja;
    }

// powiazania
	public function getListTransakcja()
	{
		if(!$this->isLoaded())
		{
			throw new InvalidArgumentException('Obiekt nie istnieje.');
		}
		$listTransakcja = new DatabaseList('Transakcja');
		$filter = new SQL_Filter(new SQL_Field('aukcja_id'), SQL_Filter::EQUAL, $this->getId());
		$listTransakcja->setFilter($filter);
		return $listTransakcja;
	}

	public function powiazTransakcja(Transakcja $transakcja)
	{
		if(!$this->isLoaded())
		{
			throw new InvalidArgumentException('Obiekt $this nie istnieje.');
		}
		if(!$transakcja->isLoaded())
		{
			throw new InvalidArgumentException('Transakcja nie istnieje.');
		}
		$transakcjaAukcja = $transakcja->getAukcja();
		if($transakcjaAukcja->getId() != $this->getId())
		{
			$transakcja->setAukcja($this);
			$transakcja->save();
		}
	}

// atrybuty
	public function getIdAllegroAukcji()
	{
		return $this->data['id_allegro_aukcja'];
	}

	public function setIdAllegroAukcji($value)
	{
		if($value != (float) $value)
		{
			throw new InvalidArgumentException('Nie poprawny format id allegro aukcja.');
		}
		$this->data['id_allegro_aukcja'] = $value;
	}

	public function getNazwa()
	{
		return $this->data['nazwa'];
	}

	public function setNazwa($value)
	{
		if($value != (string) $value)
		{
			throw new InvalidArgumentException('Nie poprawny format nazwy.');
		}
		$this->data['nazwa'] = $value;
	}

	public function getOpisProduktu()
	{
		return $this->data['opis_produktu'];
	}

	public function setOpisProduktu($value)
	{
		if($value != (string) $value)
		{
			throw new InvalidArgumentException('Nie poprawny format opisu produktu.');
		}
		$this->data['opis_produktu'] = $value;
	}

	public function getCenaSztuki()
	{
		return $this->data['cena_sztuki'];
	}

	public function setCenaSztuki($value)
	{
		if($value != (float) $value)
		{
			throw new InvalidArgumentException('Nie poprawny format ceny sztuki.');
		}
		$this->data['cena_sztuki'] = $value;
	}

	public function getDataRozpoczecia()
	{
		return $this->data['data_rozpoczecia'];
	}

	public function setDataRozpoczecia($value)
	{
		if($value != (int) $value || $value < 0)
		{
			throw new InvalidArgumentException('Nie poprawny format daty rozpoczecia.');
		}
		$this->data['data_rozpoczecia'] = $value;
	}

	public function getDataZakonczenia()
	{
		return $this->data['data_zakonczenia'];
	}

	public function setDataZakonczenia($value)
	{
		if($value != (int) $value || $value < 0)
		{
			throw new InvalidArgumentException('Nie poprawny format daty zakonczenia.');
		}
		$this->data['data_zakonczenia'] = $value;
	}
}