<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

class Klient extends Osoba
{
	protected static $table = 'klient';
	protected static $fields = array('id_allegro_klient', 'nick_allegro', 'ilosc_komentarzy_pozytywnych', 'ilosc_komentarzy_negatywnych');

    public function __construct($id = null)
    {
		if($id != null && $id != 0)
			$this->load($id, 'id');
    }

	public static function getFieldsList()
	{
		if(get_parent_class() && method_exists(get_parent_class(), 'getFieldsList'))
		{
			return array_merge(parent::getFieldsList(), self::$fields);
		}
		else
		{
			return self::$fields;
		}
	}

	public static function create($imie, $nazwisko, $ulica, $kodPocztowy, $miejscowosc, $telefon, $idAllegro, $nickAllegro, $iloscKomentarzyPozytywnych, $iloscKomentarzyNegatywnych)
    {
		$klient = new Klient();
		$klient->setImie($imie);
		$klient->setNazwisko($nazwisko);
		$klient->setUlica($ulica);
		$klient->setKodPocztowy($kodPocztowy);
		$klient->setMiejscowosc($miejscowosc);
		$klient->setTelefon($telefon);
		$klient->setIdAllegroKlienta($idAllegro);
		$klient->setNickAllegro($nickAllegro);
		$klient->setIloscKomentarzyPozytywnych($iloscKomentarzyPozytywnych);
		$klient->setIloscKomentarzyNegatywnych($iloscKomentarzyNegatywnych);
		$klient->save();
		return $klient;
    }

// powiazania
	public function getListTransakcja()
	{
		if(!$this->isLoaded())
		{
			throw new InvalidArgumentException('Obiekt nie istnieje.');
		}
		$listTransakcja = new DatabaseList('Transakcja');
		$filter = new SQL_Filter(new SQL_Field('klient_id'), SQL_Filter::EQUAL, $this->getId());
		$listTransakcja->setFilter($filter);
		return $listTransakcja;
	}

	public function powiazTransakcja(Transakcja $transakcja)
	{
		if(!$this->isLoaded())
		{
			throw new InvalidArgumentException('Obiekt $this nie istnieje.');
		}
		if(!$transakcja->isLoaded())
		{
			throw new InvalidArgumentException('Transakcja nie istnieje.');
		}
		$transakcjaKlient = $transakcja->getKlient();
		if($transakcjaKlient->getId() != $this->getId())
		{
			$transakcja->setKlient($this);
			$transakcja->save();
		}
	}

// atrybuty
	public function getIdAllegroKlienta()
	{
		return $this->data['id_allegro_klient'];
	}

	public function setIdAllegroKlienta($value)
	{
		if($value != (float) $value)
		{
			throw new InvalidArgumentException('Nie poprawny format id allegro klienta.');
		}
		$this->data['id_allegro_klient'] = $value;
	}

	public function getNickAllegro()
	{
		return $this->data['nick_allegro'];
	}

	public function setNickAllegro($value)
	{
		if($value != (string) $value || strlen($value) > 255)
		{
			throw new InvalidArgumentException('Nie poprawny format nicku allegro.');
		}
		$this->data['nick_allegro'] = $value;
	}

	public function getIloscKomentarzyPozytywnych()
	{
		return $this->data['ilosc_komentarzy_pozytywnych'];
	}

	public function setIloscKomentarzyPozytywnych($value)
	{
		if($value != (int) $value || $value < 0)
		{
			throw new InvalidArgumentException('Nie poprawny format ilosci komentarzy pozytywnych.');
		}
		$this->data['ilosc_komentarzy_pozytywnych'] = $value;
	}

	public function getIloscKomentarzyNegatywnych()
	{
		return $this->data['ilosc_komentarzy_negatywnych'];
	}

	public function setIloscKomentarzyNegatywnych($value)
	{
		if($value != (int) $value || $value < 0)
		{
			throw new InvalidArgumentException('Nie poprawny format ilosci komentarzy negatywnych.');
		}
		$this->data['ilosc_komentarzy_negatywnych'] = $value;
	}
}