<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

class PlatnoscAllegro extends Platnosc
{
	protected static $table = 'platnosc_allegro';
	protected static $fields = array('id_allegro_platnosc');

    public function __construct($id = null)
    {
		if($id != null && $id != 0)
			$this->load($id, 'id');
    }

	public static function getFieldsList()
	{
		if(get_parent_class() && method_exists(get_parent_class(), 'getFieldsList'))
		{
			return array_merge(parent::getFieldsList(), self::$fields);
		}
		else
		{
			return self::$fields;
		}
	}

// powiazania
	public function getListTransakcja()
	{
		if(!$this->isLoaded())
		{
			throw new InvalidArgumentException('PlatnoscAllegro nie istnieje.');
		}
		$listTransakcja = new DatabaseList('Transakcja');
		$filterTransakcja = new SQL_Filter(new SQL_Field('transakcja_id', 'transakcja_platnosc_allegro'), SQL_Filter::EQUAL, new SQL_Field('id', 'transakcja'));
		$filterPlatnosc = new SQL_Filter(new SQL_Field('platnosc_id', 'transakcja_platnosc_allegro'), SQL_Filter::EQUAL, $this->getId());
		$filter = new SQL_Filter($filterTransakcja, SQL_Filter::CRITERIUM_AND, $filterPlatnosc);
		$listTransakcja->setFilter($filter);
		return $listTransakcja;
	}

	public function powiazTransakcja(Transakcja $transakcja)
	{
		if(!$transakcja->isLoaded())
		{
			throw new InvalidArgumentException('Transakcja nie istnieje.');
		}
		if(!$this->isLoaded())
		{
			throw new InvalidArgumentException('PlatnoscAllegro nie istnieje.');
		}
		if(Website::getDatabaseHandler()->query('SELECT ' . Website::getDatabaseHandler()->fieldName('transakcja_id') . ', ' . Website::getDatabaseHandler()->fieldName('platnosc_id') . ' FROM ' . Website::getDatabaseHandler()->tableName('transakcja_platnosc_allegro') . ' WHERE ' . Website::getDatabaseHandler()->fieldName('transakcja_id') . ' = ' . Website::getDatabaseHandler()->quote($transakcja->getId()) . ' AND ' . Website::getDatabaseHandler()->fieldName('platnosc_id') . ' = ' . Website::getDatabaseHandler()->quote($this->getId()))->fetch() === FALSE)
		{
			Website::getDatabaseHandler()->query('INSERT INTO ' . Website::getDatabaseHandler()->tableName('transakcja_platnosc_allegro') . ' (' . Website::getDatabaseHandler()->fieldName('transakcja_id') . ', ' . Website::getDatabaseHandler()->fieldName('platnosc_id') . ') VALUES (' . Website::getDatabaseHandler()->quote($transakcja->getId()) . ', ' . Website::getDatabaseHandler()->quote($this->getId()) . ')');
		}
	}

	public function odwiazTransakcja(Transakcja $transakcja)
	{
		if(!$transakcja->isLoaded())
		{
			throw new InvalidArgumentException('Transakcja nie istnieje.');
		}
		if(!$this->isLoaded())
		{
			throw new InvalidArgumentException('PlatnoscAllegro nie istnieje.');
		}
        Website::getDatabaseHandler()->query('DELETE FROM ' . Website::getDatabaseHandler()->tableName('transakcja_platnosc_allegro') . ' WHERE ' . Website::getDatabaseHandler()->fieldName('transakcja_id') . ' = ' . Website::getDatabaseHandler()->quote($transakcja->getId()) . ' AND ' . Website::getDatabaseHandler()->fieldName('platnosc_id') . ' = ' . Website::getDatabaseHandler()->quote($this->getId()));
	}


// atrybuty
	public function getIdAllegroPlatnosci()
	{
		return $this->data['id_allegro_platnosc'];
	}

	public function setIdAllegroPlatnosci($value)
	{
		if($value != (float) $value)
		{
			throw new InvalidArgumentException('Nie poprawny format id allegro platnosci.');
		}
		$this->data['id_allegro_platnosc'] = $value;
	}
}