<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

class PlatnoscBank extends Platnosc
{
	protected static $table = 'platnosc_bank';
	protected static $fields = array('dane_adresowe', 'numer_konta', 'tytul_przelewu');

    public function __construct($id = null)
    {
		if($id != null && $id != 0)
			$this->load($id, 'id');
    }

	public static function getFieldsList()
	{
		if(get_parent_class() && method_exists(get_parent_class(), 'getFieldsList'))
		{
			return array_merge(parent::getFieldsList(), self::$fields);
		}
		else
		{
			return self::$fields;
		}
	}

// powiazania
	public function getListTransakcja()
	{
		if(!$this->isLoaded())
		{
			throw new InvalidArgumentException('PlatnoscBank nie istnieje.');
		}
		$listTransakcja = new DatabaseList('Transakcja');
		$filterTransakcja = new SQL_Filter(new SQL_Field('transakcja_id', 'transakcja_platnosc_bank'), SQL_Filter::EQUAL, new SQL_Field('id', 'transakcja'));
		$filterPlatnosc = new SQL_Filter(new SQL_Field('platnosc_id', 'transakcja_platnosc_bank'), SQL_Filter::EQUAL, $this->getId());
		$filter = new SQL_Filter($filterTransakcja, SQL_Filter::CRITERIUM_AND, $filterPlatnosc);
		$listTransakcja->setFilter($filter);
		return $listTransakcja;
	}

	public function powiazTransakcja(Transakcja $transakcja)
	{
		if(!$transakcja->isLoaded())
		{
			throw new InvalidArgumentException('Transakcja nie istnieje.');
		}
		if(!$this->isLoaded())
		{
			throw new InvalidArgumentException('PlatnoscBank nie istnieje.');
		}
		if(Website::getDatabaseHandler()->query('SELECT ' . Website::getDatabaseHandler()->fieldName('transakcja_id') . ', ' . Website::getDatabaseHandler()->fieldName('platnosc_id') . ' FROM ' . Website::getDatabaseHandler()->tableName('transakcja_platnosc_bank') . ' WHERE ' . Website::getDatabaseHandler()->fieldName('transakcja_id') . ' = ' . Website::getDatabaseHandler()->quote($transakcja->getId()) . ' AND ' . Website::getDatabaseHandler()->fieldName('platnosc_id') . ' = ' . Website::getDatabaseHandler()->quote($this->getId()))->fetch() === FALSE)
		{
			Website::getDatabaseHandler()->query('INSERT INTO ' . Website::getDatabaseHandler()->tableName('transakcja_platnosc_bank') . ' (' . Website::getDatabaseHandler()->fieldName('transakcja_id') . ', ' . Website::getDatabaseHandler()->fieldName('platnosc_id') . ') VALUES (' . Website::getDatabaseHandler()->quote($transakcja->getId()) . ', ' . Website::getDatabaseHandler()->quote($this->getId()) . ')');
		}
	}

	public function odwiazTransakcja(Transakcja $transakcja)
	{
		if(!$transakcja->isLoaded())
		{
			throw new InvalidArgumentException('Transakcja nie istnieje.');
		}
		if(!$this->isLoaded())
		{
			throw new InvalidArgumentException('PlatnoscBank nie istnieje.');
		}
        Website::getDatabaseHandler()->query('DELETE FROM ' . Website::getDatabaseHandler()->tableName('transakcja_platnosc_bank') . ' WHERE ' . Website::getDatabaseHandler()->fieldName('transakcja_id') . ' = ' . Website::getDatabaseHandler()->quote($transakcja->getId()) . ' AND ' . Website::getDatabaseHandler()->fieldName('platnosc_id') . ' = ' . Website::getDatabaseHandler()->quote($this->getId()));
	}


// atrybuty
	public function getDaneAdresowe()
	{
		return $this->data['dane_adresowe'];
	}

	public function setDaneAdresowe($value)
	{
		if($value != (string) $value)
		{
			throw new InvalidArgumentException('Nie poprawny format danych adresowych.');
		}
		$this->data['dane_adresowe'] = $value;
	}

	public function getNumerKonta()
	{
		return $this->data['numer_konta'];
	}

	public function setNumerKonta($value)
	{
		if($value != (string) $value || strlen($value) > 255)
		{
			throw new InvalidArgumentException('Nie poprawny format numeru konta.');
		}
		$this->data['numer_konta'] = $value;
	}

	public function getTytulPrzelewu()
	{
		return $this->data['tytul_przelewu'];
	}

	public function setTytulPrzelewu($value)
	{
		if($value != (string) $value)
		{
			throw new InvalidArgumentException('Nie poprawny format tytulu przelewu.');
		}
		$this->data['tytul_przelewu'] = $value;
	}
}