<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

// usuwa 'magic quotes' jesli sa aktywowane
if(function_exists('get_magic_quotes_gpc') && get_magic_quotes_gpc())
{
    $process = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
    while(list($key, $val) = each($process))
	{
        foreach ($val as $k => $v)
		{
            unset($process[$key][$k]);
            if(is_array($v))
			{
                $process[$key][stripslashes($k)] = $v;
                $process[] = &$process[$key][stripslashes($k)];
            }
			else
                $process[$key][stripslashes($k)] = stripslashes($v);
        }
    }
    unset($process);
}

// wczytywanie wybranego kontrolera i akcji
$params = explode('/', trim(substr($_SERVER['REQUEST_URI'], strlen(dirname($_SERVER['SCRIPT_NAME']))), '/'));
if(count($params) >= 2 && !empty($params[0]) && !empty($params[1]))
{
	$controller = ucwords($params[0]);
	$action = $params[1];
}
else
{
	Website::redirect(Website::getWebsiteConfig()->getValue('defaultController'), Website::getWebsiteConfig()->getValue('defaultAction'));
}

// walidacja nazwy kontrolera i akcji [a-zA-Z0-9_]
if(!Functions::isValidControllerName($controller))
{
	throw new CriticException('Nie poprawna nazwa kontrolera: ' . htmlspecialchars($controller));
}
if(!Functions::isValidActionName($action))
{
	throw new CriticException('Nie poprawna nazwa akcji: ' . htmlspecialchars($action));
}

// jesli nie zalogowany to moze odwiedzic tylko strone logowania
if(!Visitor::isLogged() && $controller != 'Rola' && $action != 'login')
{
	Website::redirect('Rola', 'login');
}

$controllerName = $controller;
$controller .= '_Controller';
$actionName = $action;
$action .= 'Action';
View::initialize($controllerName, $actionName);
// domyslnie: $controllerObject = new __Controller('_UserStatus')
$controllerObject = new $controller($controllerName);
// domyslnie: $controllerObject->loginAction()
if(method_exists($controllerObject, $action))
{
    $controllerObject->{$action}();
}
else 
{
	throw new CriticException('Akcja ' . $action . ' nie istnieje w kontrolerze ' . $controller);
}
echo View::render();