<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

class Controller 
{
	private $controllerName = "";
	private static $lastError;

	public function __construct($controllerName)
	{
		$this->controllerName = $controllerName;
	}

	public static function verifyArguments($data, $requiredList, &$vars)
	{
		// dodac zmienne do $GLOBALS, zeby moc potem uzywac $login itp.
		foreach($requiredList as $requiredVariable)
		{
			if(!isset($data[$requiredVariable->getName()]))
			{
				if($requiredVariable->hasDefaultValue())
				{
					$data[$requiredVariable->getName()] = $requiredVariable->getDefaultValue();
				}
				else
				{
					self::$lastError = 'Nie otrzymano argumentu ' . htmlspecialchars($requiredVariable->getName());
					return false;
				}
			}
			if(!$requiredVariable->validate($data[$requiredVariable->getName()]))
			{
				self::$lastError = $requiredVariable->getError();
				return false;
			};
			$vars[$requiredVariable->getName()] = $data[$requiredVariable->getName()];
		}
		return true;
	}
	
	public static function getLastError()
	{
		return self::$lastError;
	}
}