<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

class Functions
{
	public static function link($controller, $action)
	{
		return Website::getWebsiteConfig()->getValue('pageURL') . DS . $controller . DS . $action . DS;
	}

	public static function fieldToName($field)
	{
		/*
		$name = "";
		for($i=0; $i < strlen($field); $i++)
		{
			if($field[$i] == '_' && isset($field[$i+1]) && ord($field[$i+1]) >= ord('a') && ord($field[$i+1]) <= ord('z'))
			{
				$i++;
				$name .= ' ' . chr(ord($field[$i]) - 32);
			}
			else
			{
				$name .= $field[$i];
			}
		}
		*/
		return ucwords(str_replace('_', ' ', $field));
	}

	public static function encodeJsonData($data)
	{
		foreach($data as $key => $value)
		{
			if(is_array($value))
			{
				$data[$key] = Functions::encodeJsonData($value);
			}
			else
			{
				$data[$key] = utf8_encode(base64_encode($value));
			}
		}
		return $data;
	}

	public static function decodeJsonData($data)
	{
		foreach($data as $key => $value)
		{
			if(is_array($value))
			{
				$data[$key] = Functions::decodeJsonData($value);
			}
			else
			{
				$data[$key] = utf8_decode(base64_decode($value));
			}
		}
		return $data;
	}

	public static function isValidFolderName($string)
	{
		return (strspn($string, "qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM0123456789_") == strlen($string));
	}

	public static function isValidControllerName($string)
	{
		return (strspn($string, "qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM0123456789_") == strlen($string));
	}

	public static function isValidActionName($string)
	{
		return (strspn($string, "qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM0123456789_") == strlen($string));
	}

	public static function isValidNewAccountName($string)
	{
		$config = Website::getConfig(array('account', 'name'));

		if($config->isSetKey('nameAllowedLetters') && strspn($string, $config->getValue('nameAllowedLetters')) != strlen($string))
			return array(false, '<b>Account Name</b> contains illegal characters, use only: <b>' . $config->getValue('nameAllowedLetters') . '</b>');
		if($config->isSetKey('nameMaximumLength') && strlen($string) > $config->getValue('nameMaximumLength'))
			return array(false, '<b>Account Name</b> is too long. Maximum: <b>' . $config->getValue('nameMaximumLength') . '</b> letters');
		if($config->isSetKey('nameMinimumLength') && strlen($string) < $config->getValue('nameMinimumLength'))
			return array(false, '<b>Account Name</b> is too short. Minimum: <b>' . $config->getValue('nameMinimumLength') . '</b> letters');

		return array(true, '');
	}

	public static function isValidNewPassword($string)
	{
		$config = Website::getConfig(array('account', 'password'));

		if($config->isSetKey('passwordAllowedLetters') && strspn($string, $config->getValue('passwordAllowedLetters')) != strlen($string))
			return array(false, '<b>Password</b> contains illegal characters, use only: <b>' . $config->getValue('passwordAllowedLetters') . '</b>');
		if($config->isSetKey('passwordMaximumLength') && strlen($string) > $config->getValue('passwordMaximumLength'))
			return array(false, '<b>Password</b> is too long. Maximum: <b>' . $config->getValue('passwordMaximumLength') . '</b> letters');
		if($config->isSetKey('passwordMinimumLength') && strlen($string) < $config->getValue('passwordMinimumLength'))
			return array(false, '<b>Password</b> is too short. Minimum: <b>' . $config->getValue('passwordMinimumLength') . '</b> letters');

		return array(true, '');
	}

	public static function isValidMail($email)
	{
		return (filter_var($email, FILTER_VALIDATE_EMAIL) != false);
	}

	public function limitTextLength($text, $length_limit)
	{
		if(strlen($text) > $length_limit)
			return substr($text, 0, strrpos(substr($text, 0, $length_limit), " ")).'...';
		else
			return $text;
	}
}
?>