<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

class Model extends DatabaseHandler
{
	protected static $table = '';
	protected static $fields = array('id');
	
	public function load($searchValue, $searchColumn = 'id')
	{
		if(!in_array($searchColumn, static::getFieldsList()))
		{
			throw new CriticException( __METHOD__ . ' - nie da sie zaladowac uzywajac kolumny: ' . htmlspecialchars($searchColumn));
		}
		$search_string = $this->getDatabaseHandler()->fieldName($searchColumn) . ' = ' . $this->getDatabaseHandler()->quote($searchValue);
		$fieldsArray = array();
		foreach(static::getFieldsList() as $fieldName)
		{
			$fieldsArray[$fieldName] = $this->getDatabaseHandler()->fieldName($fieldName);
		}
		$this->data = $this->getDatabaseHandler()->query('SELECT ' . implode(', ', $fieldsArray) . ' FROM ' . $this->getDatabaseHandler()->tableName(static::getTable()) . ' WHERE ' . $search_string)->fetch();
	}

	public function save($forceInsert = false)
	{
		if(!isset($this->data['id']) || $forceInsert)
		{
			$keys = array();
			$values = array();
			foreach(static::getFieldsList() as $key)
				if($key != 'id')
				{
					$keys[] = $this->getDatabaseHandler()->fieldName($key);
					$values[] = $this->getDatabaseHandler()->quote($this->data[$key]);
				}
			$this->getDatabaseHandler()->query('INSERT INTO ' . $this->getDatabaseHandler()->tableName(static::getTable()) . ' (' . implode(', ', $keys) . ') VALUES (' . implode(', ', $values) . ')');
			$this->setID($this->getDatabaseHandler()->lastInsertId());
		}
		else
		{
			$updates = array();
			foreach(static::getFieldsList() as $key)
				if($key != 'id')
					$updates[] = $this->getDatabaseHandler()->fieldName($key) . ' = ' . $this->getDatabaseHandler()->quote($this->data[$key]);
			$this->getDatabaseHandler()->query('UPDATE ' . $this->getDatabaseHandler()->tableName(static::getTable()) . ' SET ' . implode(', ', $updates) . ' WHERE ' . $this->getDatabaseHandler()->fieldName('id') . ' = ' . $this->getDatabaseHandler()->quote($this->data['id']));
		}
	}

    public function delete()
    {
        $this->getDatabaseHandler()->query('DELETE FROM ' . $this->getDatabaseHandler()->tableName(static::getTable()) . ' WHERE ' . $this->getDatabaseHandler()->fieldName('id') . ' = ' . $this->getDatabaseHandler()->quote($this->data['id']));

        unset($this->data['id']);
    }

	public function setID($value)
	{
		if($value != (int) $value || $value <= 0)
		{
			throw new InvalidArgumentException('Nie poprawny format ID.');
		}
		$this->data['id'] = $value;
	}

	public function getId()
	{
		return $this->data['id'];
	}

	public static function getTable()
	{
		return static::$table;
	}

	public static function getFieldsList()
	{
		if(get_parent_class() && method_exists(get_parent_class(), 'getFieldsList'))
		{
			return array_merge(parent::getFieldsList(), self::$fields);
		}
		else
		{
			return self::$fields;
		}
	}

	public function loadData($data)
	{
		$this->data = $data;
	}

	public function isLoaded()
	{
		return isset($this->data['id']);
	}

	public function get($field)
	{
		if(!isset($this->data[$field]))
		{
			throw new CriticException('Dane kolumny <b>' . $field . '</b> nie istnieja/nie sa zaladowane.');
		}
		return $this->data[$field];
	}
}