<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

class View 
{
	private static $controller;
	private static $action;
	private static $data = array();
	private static $template = "";
	private static $isJSON = false;

    public static function initialize($controller, $action)
    {
		self::$controller = $controller;
		self::$action = $action;
    }

    public static function setData($data)
    {
		self::$data = $data;
    }

	public static function setTemplate($templateName)
	{
		self::$template = '_' . $templateName;
	}

	public static function setIsJSON($isJSON)
	{
		self::$isJSON = $isJSON;
	}

	public static function render()
	{
		if(self::$isJSON)
		{
			return self::renderJSON();
		}
		else
		{
			return self::renderLayout();
		}
	}

	private static function renderJSON()
	{
		return json_encode(self::$data);
	}

	private static function renderLayout()
	{
		ob_start();
		extract(self::$data);
		include(HOME . DS . 'application' . DS . 'views' . DS . strtolower(self::$controller) . '_' . strtolower(self::$action) . strtolower(self::$template) . '.tpl.php');
		$pageContent = ob_get_clean();

		ob_start();
		include(HOME . DS . 'application' . DS . 'layout' . DS . 'index.php');
		$pageLayout = ob_get_clean();
		$pageLayout = str_ireplace('|PAGE_URL|', Website::getWebsiteConfig()->getValue('pageURL'), $pageLayout);
		$pageLayout = str_ireplace('|CONTENT|', $pageContent, $pageLayout);
		return $pageLayout;
	}
}