<?php
if(!defined('INITIALIZED'))
	die('Brak dostepu.');

class Visitor
{
	const LOGINSTATE_NOT_TRIED = 1;
	const LOGINSTATE_NO_ACCOUNT = 2;
	const LOGINSTATE_WRONG_PASSWORD = 3;
	const LOGINSTATE_LOGGED = 4;

	private static $account;
	private static $loginState = self::LOGINSTATE_NOT_TRIED;

	public static function getAccount()
	{
		if(!isset(self::$account))
			self::loadAccount();

		return self::$account;
	}

	public static function loadAccount()
	{
		self::$account = new Pracownik();
		if(isset($_SESSION['login']) && isset($_SESSION['password']))
		{
			self::$account->loadByLogin($_SESSION['login']);
			if(self::$account->isLoaded())
				if(self::$account->isValidPassword($_SESSION['password']))
					self::$loginState = self::LOGINSTATE_LOGGED;
				else
					self::$loginState = self::LOGINSTATE_WRONG_PASSWORD;
			else
				self::$loginState = self::LOGINSTATE_NO_ACCOUNT;
		}
		else
			self::$loginState = self::LOGINSTATE_NOT_TRIED;
		if(self::$loginState != self::LOGINSTATE_LOGGED)
		{
			self::$account = new Pracownik();
			unset($_SESSION['account']);
			unset($_SESSION['password']);
		}
	}

	public static function getLoginState()
	{
		return self::$loginState;
	}

	public static function isLogged()
	{
		return self::getAccount()->isLoaded();
	}

	public static function login($login, $password)
	{
		$_SESSION['login'] = (string) $login;
		$_SESSION['password'] = (string) $password;
		// wymusza ponowne zaladowanie danych z bazy
		self::loadAccount();
	}

	public static function logout()
	{
		unset($_SESSION['account']);
		unset($_SESSION['password']);
		self::$account = new Pracownik();
		self::$loginState = self::LOGINSTATE_NOT_TRIED;
	}

	public static function verifyAccess($accessList)
	{
		$stanowisko = self::getAccount()->getStanowisko();
		if(!in_array($stanowisko, $accessList))
		{
			throw new CriticException('Twoje stanowisko nie ma dostepu do tej podstrony.');
		}
	}
}